<?php
/**
 * Template part for displaying front page pricing.
 *
 * @package Moral
 */

$default = emerge_get_default_mods();
$pricing = get_theme_mod( 'emerge_enable_pricing', true );

if ( ! $pricing ) {
    return;
}

$section_title   = get_theme_mod( 'emerge_pricing_title', $default['emerge_pricing_title'] );
$section_sub_title = get_theme_mod( 'emerge_pricing_sub_title', $default['emerge_pricing_sub_title'] );
?>
<div id="pricing" class="relative page-section">
	<div class="wrapper">
		<div class="section-header">
            <h2 class="section-title"><?php echo esc_html( $section_title ); ?></h2>
            <h5 class="section-subtitle"><?php echo esc_html( $section_sub_title ); ?></h5>
        </div><!-- .section-header -->
        <?php  
        $widget_count = emerge_count_widgets( 'pricing-table' );
        $col_class = ( $widget_count > 4 ) ? 4 : $widget_count;
        ?>
        <!-- supports col-1, col-2, col-3, col-4 -->
        <div class="section-content col-<?php echo esc_attr( $col_class );?>">
            <?php 
            if ( is_active_sidebar( 'pricing-table' ) ) {
                dynamic_sidebar( 'pricing-table' );
            }
            ?>
        </div><!-- .section-content -->
	</div><!-- .wrapper -->
</div><!-- #pricing -->