<?php
/**
 * Moral Theme Customizer
 *
 * @package Moral
 */

/**
 * Get all the default values of the theme mods.
 */
function emerge_get_default_mods() {
	$emerge_default_mods = array(
		// Hero content.
		'emerge_hero_content_image'	=> get_theme_file_uri( '/assets/img/header-image.jpg' ),
		'emerge_hero_content_text'	=> esc_html__( 'We design thoughtful, liveable, best creative design', 'emerge-pro' ),


		// About
		'emerge_about_title' => esc_html__( 'About Emerge Pro', 'emerge-pro' ),
		'emerge_about_sub_title' => esc_html__( 'This is a beautiful place to show who you are', 'emerge-pro' ),
		'emerge_about_content' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur placerat neque rhoncus, porta arcu quis, accumsan mi. Fusce a risus ut odio aliquet porta. Quisque laoreet tristique turpis sit amet dictum. Proin nec mauris sodales, sollicitudin nunc ut, hendrerit nulla. Nunc feugiat vulputate massa, non pharetra tellus fermentum eu. Nam in quam pellentesque, elementum enim quis, dapibus mi. Vivamus at pulvinar neque. ', 'emerge-pro' ),
		'emerge_about_btn_txt' => esc_html__( 'Read More', 'emerge-pro' ),

		// CTA
		'emerge_cta_title' => esc_html__( 'This is call to action section', 'emerge-pro' ),
		'emerge_cta_text' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur placerat neque rhoncus, porta arcu quis, accumsan mi. Fusce a risus ut odio aliquet porta. ', 'emerge-pro' ),
		'emerge_cta_image' => get_theme_file_uri( '/assets/img/call-to-action.jpg' ),
		'emerge_cta_btn_txt' => esc_html__( 'Read More', 'emerge-pro' ),

		// Portfolio
		'emerge_portfolio_image' => get_theme_file_uri( '/assets/img/header-image.jpg' ),
		'emerge_portfolio_custom_content' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Curabitur placerat neque rhoncus, porta arcu quis...', 'emerge-pro' ),
		'emerge_portfolio_custom_title' => esc_html__( 'Wooden Texture', 'emerge-pro' ),
		'emerge_portfolio_title' => esc_html__( 'Our Portfolio', 'emerge-pro' ),
		'emerge_portfolio_sub_title' => esc_html__( 'Display your best work in a beautiful way', 'emerge-pro' ),

		// Services
		'emerge_services_image' => get_theme_file_uri( '/assets/img/header-image.jpg' ),
		'emerge_services_custom_content' => esc_html__( 'In placerat faucibus dolor, ut scelerisque sapien pretium finibus. Nam vestibulum dui eu augue feugiat, sed ullamcorper velit mollis. ', 'emerge-pro' ),
		'emerge_services_custom_title' => esc_html__( 'Digital Strategy', 'emerge-pro' ),
		'emerge_services_title' => esc_html__( 'Our Services', 'emerge-pro' ),
		'emerge_services_sub_title' => esc_html__( 'Display your digital services here', 'emerge-pro' ),

		// Reasons
		'emerge_reasons_title' => esc_html__( 'Why Choose Us?', 'emerge-pro' ),
		'emerge_reasons_custom_content' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque cursus elit odio, quis tincidunt est congue at. Praesent porttitor justo vitae felis suscipit blandit. Aliquam in sollicitudin nisl, eu interdum nisl. Integer in nulla leo.', 'emerge-pro' ),

		'emerge_reasons_sub_title' => esc_html__( 'Show people how good you are in business', 'emerge-pro' ),

		// Team
		'emerge_team_title' => esc_html__( 'Our Team', 'emerge-pro' ),
		'emerge_team_sub_title' => esc_html__( 'Display your creative Team in a Clean way', 'emerge-pro' ),
		'emerge_team_custom_title' => esc_html__( 'Rena Kownacki', 'emerge-pro' ),
		'emerge_team_custom_position' => esc_html__( 'Managing Director', 'emerge-pro' ),
		'emerge_team_image' => get_theme_file_uri( '/assets/img/team-01.jpg' ),

		// Testimonials
		'emerge_testimonial_custom_content' => esc_html__( 'Maecenas fermentum, sem in feugiat tincidunt, leo erat tincidunt lectus, sed tempus urna nisi non mauris. Aenean vitae fringilla odio.Aliquam sagittis, leo pellentesque volutpat viverra, nibh erat vehicula nisi, et lacinia metus ligula eu purus.', 'emerge-pro' ),
		'emerge_testimonial_custom_name' => esc_html__( 'Alana Louise, CEO at Moral Themes', 'emerge-pro' ),
		'emerge_testimonial_title' => esc_html__( 'Our Testimonials', 'emerge-pro' ),
		'emerge_testimonial_sub_title' => esc_html__( 'Thoughts of your clients for Services you have provided', 'emerge-pro' ),

		// Subscribe
		'emerge_subscribe_title' => esc_html__( 'Subscribe Now', 'emerge-pro' ),
		'emerge_subscribe_text' => esc_html__( 'Lorem ipsum dolor sit amet, consectetur adipiscing elit. Pellentesque cursus elit odio, quis tincidunt est congue at. Praesent porttitor justo vitae felis suscipit blandit. Aliquam in sollicitudin nisl, eu interdum nisl. Integer in nulla leo.', 'emerge-pro' ),
		'emerge_subscribe_placeholder' => esc_html__( 'Enter your email', 'emerge-pro' ),
		'emerge_subscribe_btn_text' => esc_html__( 'Subscribe', 'emerge-pro' ),
		'emerge_success_msg' => esc_html__( "Success! An email was just sent to confirm your subscription. Please find the email now and click 'Confirm Follow' to start subscribing.", 'emerge-pro' ),
		'emerge_subscribe_bg_image' => get_theme_file_uri( '/assets/img/subscribe-bg.jpg' ),

		// Pricing
		'emerge_pricing_title' => esc_html__( 'Pricing', 'emerge-pro' ),
		'emerge_pricing_sub_title' => esc_html__( 'Display your monthly & yearly plans', 'emerge-pro' ),

		// Blog section
		'emerge_blog_section_title' => esc_html__( 'Latest From Blog', 'emerge-pro' ),
		'emerge_blog_section_sub_title' => esc_html__( 'Show people what is happening around you recently', 'emerge-pro' ),

		// Contact section
		'emerge_contact_title' => esc_html__( 'Get in Touch', 'emerge-pro' ),
		'emerge_contact_sub_title' => esc_html__( 'We would love to hear from you anytime', 'emerge-pro' ),

		// Footer copyright
		'emerge_copyright_txt' => sprintf( esc_html__( 'Theme: %1$s by %2$s.', 'emerge-pro' ), 'Emerge Pro', '<a href="' . esc_url( 'http://moralthemes.com/' ) . '">Moral Themes</a>' ),
	);

	return apply_filters( 'emerge_default_mods', $emerge_default_mods );
}

/**
 * Add postMessage support for site title and description for the Theme Customizer.
 *
 * @param WP_Customize_Manager $wp_customize Theme Customizer object.
 */
function emerge_customize_register( $wp_customize ) {
	/**
	 * Separator custom control
	 *
	 * @version 1.0.0
	 * @since  1.0.0
	 */
	class Emerge_Separator_Custom_Control extends WP_Customize_Control {
		/**
		 * Control type
		 *
		 * @var string
		 */
		public $type = 'emerge-separator';
		/**
		 * Control method
		 *
		 * @since 1.0.0
		 */
		public function render_content() {
			?>
			<p><hr style="border-color: #222; opacity: 0.2;"></p>
			<?php
		}
	}

	$default = emerge_get_default_mods();

	$wp_customize->get_setting( 'blogname' )->transport         = 'postMessage';
	$wp_customize->get_setting( 'blogdescription' )->transport  = 'postMessage';
	$wp_customize->get_setting( 'header_textcolor' )->transport = 'postMessage';

	if ( isset( $wp_customize->selective_refresh ) ) {
		$wp_customize->selective_refresh->add_partial( 'blogname', array(
			'selector'        => '.site-title a',
			'render_callback' => 'emerge_customize_partial_blogname',
		) );
		$wp_customize->selective_refresh->add_partial( 'blogdescription', array(
			'selector'        => '.site-description',
			'render_callback' => 'emerge_customize_partial_blogdescription',
		) );
	}

	// Header text display setting
	$wp_customize->add_setting(	
		'emerge_header_text_display',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_header_text_display',
		array(
			'section'		=> 'title_tagline',
			'type'			=> 'checkbox',
			'label'			=> esc_html__( 'Display Site Title and Tagline', 'emerge-pro' ),
		)
	);

	// Header title color setting
	$wp_customize->add_setting(	
		'emerge_header_title_color',
		array(
			'sanitize_callback' => 'emerge_sanitize_hex_color',
			'default' => '#cf3140',
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Color_Control( 
		$wp_customize,
			'emerge_header_title_color',
			array(
				'section'		=> 'colors',
				'label'			=> esc_html__( 'Header Text Color:', 'emerge-pro' ),
			)
		)
	);

	// Header tagline color setting
	$wp_customize->add_setting(	
		'emerge_header_tagline',
		array(
			'sanitize_callback' => 'emerge_sanitize_hex_color',
			'default' => '#2e2e2e',
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Color_Control( 
		$wp_customize,
			'emerge_header_tagline',
			array(
				'section'		=> 'colors',
				'label'			=> esc_html__( 'Header Tagline Color:', 'emerge-pro' ),
			)
		)
	);

	// Your latest posts title setting
	$wp_customize->add_setting(	
		'emerge_your_latest_posts_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => esc_html__( 'Blogs', 'emerge-pro' ),
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_your_latest_posts_title',
		array(
			'section'		=> 'static_front_page',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_is_latest_posts'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_your_latest_posts_title', 
		array(
	        'selector'            => '.home.blog #page-header .page-title',
			'render_callback'     => 'emerge_your_latest_posts_partial_title',
    	) 
    );

	/**
	 *
	 * 
	 * Home sections panel
	 *
	 * 
	 */
	// Home sections panel
	$wp_customize->add_panel(
		'emerge_home_panel',
		array(
			'title' => esc_html__( 'Homepage Sections Settings', 'emerge-pro' ),
			'priority' => 130
		)
	);

	// Hero content section
	$wp_customize->add_section(
		'emerge_hero_content',
		array(
			'title' => esc_html__( 'Hero Content', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Hero content enable settings
	$wp_customize->add_setting(
		'emerge_hero_content',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Hero content enable on entire site settings
	$wp_customize->add_setting(
		'emerge_hero_content_enable_on_entire',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => false,
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content_enable_on_entire',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Enable on entire site.', 'emerge-pro' ),
			'active_callback' => 'emerge_if_hero_content_enable',
			'type'			=> 'checkbox',
		)
	);

	// Hero content post setting
	$wp_customize->add_setting(
		'emerge_hero_content_post',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content_post',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Post:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_hero_content_post',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_choices(),
		)
	);

	// Hero content page setting
	$wp_customize->add_setting(
		'emerge_hero_content_page',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content_page',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Page:', 'emerge-pro' ),
			'type'			=> 'dropdown-pages',
			'active_callback' => 'emerge_if_hero_content_page'
		)
	);

	// Hero content image setting
	$wp_customize->add_setting(
		'emerge_hero_content_image',
		array(
			'sanitize_callback' => 'emerge_sanitize_image',
			'default'		=> $default['emerge_hero_content_image'],
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Image_Control(
			$wp_customize,
			'emerge_hero_content_image',
			array(
				'section'		=> 'emerge_hero_content',
				'label'			=> esc_html__( 'Image:', 'emerge-pro' ),
				'active_callback' => 'emerge_if_hero_content_custom',
			)
		)
	);

	// Hero content text setting
	$wp_customize->add_setting(
		'emerge_hero_content_text',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
			'transport'	=> 'postMessage',
			'default' => $default['emerge_hero_content_text'],
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content_text',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Text:', 'emerge-pro' ),
			'type'			=> 'textarea',
			'active_callback' => 'emerge_if_hero_content_custom'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_hero_content_text', 
		array(
	        'selector'            => '#custom-header-media .entry-header a',
			'render_callback'     => 'emerge_hero_content_partial_text',
    	) 
    );

	// Hero content link setting
	$wp_customize->add_setting(
		'emerge_hero_content_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default' => '#',
		)
	);

	$wp_customize->add_control(
		'emerge_hero_content_link',
		array(
			'section'		=> 'emerge_hero_content',
			'label'			=> esc_html__( 'Link:', 'emerge-pro' ),
			'type'			=> 'url',
			'active_callback' => 'emerge_if_hero_content_custom'
		)
	);

	/**
	 * About section
	 */
	// About section
	$wp_customize->add_section(
		'emerge_about',
		array(
			'title' => esc_html__( 'About', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// About enable settings
	$wp_customize->add_setting(
		'emerge_about',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_about',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// About post setting
	$wp_customize->add_setting(
		'emerge_about_post',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_about_post',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Post:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_about_post',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_choices(),
		)
	);

	// About page setting
	$wp_customize->add_setting(
		'emerge_about_page',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_about_page',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Page:', 'emerge-pro' ),
			'type'			=> 'dropdown-pages',
			'active_callback' => 'emerge_if_about_page'
		)
	);

	// About image setting
	$wp_customize->add_setting(
		'emerge_about_image',
		array(
			'sanitize_callback' => 'emerge_sanitize_image',
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Image_Control(
			$wp_customize,
			'emerge_about_image',
			array(
				'section'		=> 'emerge_about',
				'label'			=> esc_html__( 'Image:', 'emerge-pro' ),
				'active_callback' => 'emerge_if_about_custom',
			)
		)
	);

	// About title setting
	$wp_customize->add_setting(
		'emerge_about_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_about_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_about_title',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_about_custom'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_about_title', 
		array(
	        'selector'            => '#about-us .section-title',
			'render_callback'     => 'emerge_about_partial_title',
    	) 
    );

	// About sub title setting
	$wp_customize->add_setting(
		'emerge_about_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_about_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_about_sub_title',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Sub title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_about_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_about_sub_title', 
		array(
	        'selector'            => '#about-us .section-subtitle',
			'render_callback'     => 'emerge_about_partial_sub_title',
    	) 
    );

	// About content setting
	$wp_customize->add_setting(
		'emerge_about_content',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
			'default' => $default['emerge_about_content'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_about_content',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Content:', 'emerge-pro' ),
			'type'			=> 'textarea',
			'active_callback' => 'emerge_if_about_custom'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_about_content', 
		array(
	        'selector'            => '#about-us .entry-content',
			'render_callback'     => 'emerge_about_partial_content',
    	) 
    );

	// About button text setting
	$wp_customize->add_setting(
		'emerge_about_btn_txt',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_about_btn_txt'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_about_btn_txt',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Button Text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_about_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_about_btn_txt', 
		array(
	        'selector'            => '#about-us .read-more a',
			'render_callback'     => 'emerge_about_partial_btn_txt',
    	) 
    );

	// About link setting
	$wp_customize->add_setting(
		'emerge_about_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default' => '#',
		)
	);

	$wp_customize->add_control(
		'emerge_about_link',
		array(
			'section'		=> 'emerge_about',
			'label'			=> esc_html__( 'Button Link:', 'emerge-pro' ),
			'type'			=> 'url',
			'active_callback' => 'emerge_if_about_custom'
		)
	);

	/**
	 * CTA section
	 */
	// CTA section
	$wp_customize->add_section(
		'emerge_cta',
		array(
			'title' => esc_html__( 'Call to action', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// CTA enable settings
	$wp_customize->add_setting(
		'emerge_cta',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_cta',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// CTA post setting
	$wp_customize->add_setting(
		'emerge_cta_post',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_cta_post',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Post:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_cta_post',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_choices(),
		)
	);

	// CTA page setting
	$wp_customize->add_setting(
		'emerge_cta_page',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_cta_page',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Page:', 'emerge-pro' ),
			'type'			=> 'dropdown-pages',
			'active_callback' => 'emerge_if_cta_page'
		)
	);

	// CTA image setting
	$wp_customize->add_setting(
		'emerge_cta_image',
		array(
			'sanitize_callback' => 'emerge_sanitize_image',
			'default'		=> $default['emerge_cta_image'],
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Image_Control(
			$wp_customize,
			'emerge_cta_image',
			array(
				'section'		=> 'emerge_cta',
				'label'			=> esc_html__( 'Image:', 'emerge-pro' ),
				'active_callback' => 'emerge_if_cta_custom',
			)
		)
	);

	// CTA title setting
	$wp_customize->add_setting(
		'emerge_cta_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_cta_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_cta_title',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_cta_custom'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_cta_title', 
		array(
	        'selector'            => '#call-to-action .section-title',
			'render_callback'     => 'emerge_cta_partial_title',
    	) 
    );

	// CTA text setting
	$wp_customize->add_setting(
		'emerge_cta_text',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
			'transport'	=> 'postMessage',
			'default' => $default['emerge_cta_text'],
		)
	);

	$wp_customize->add_control(
		'emerge_cta_text',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Text:', 'emerge-pro' ),
			'type'			=> 'textarea',
			'active_callback' => 'emerge_if_cta_custom'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_cta_text', 
		array(
	        'selector'            => '#call-to-action .section-content',
			'render_callback'     => 'emerge_cta_partial_text',
    	) 
    );

	// CTA button text setting
	$wp_customize->add_setting(
		'emerge_cta_btn_txt',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_cta_btn_txt'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_cta_btn_txt',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Button Text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_cta_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_cta_btn_txt', 
		array(
	        'selector'            => '#call-to-action .read-more a',
			'render_callback'     => 'emerge_cta_partial_btn_txt',
    	) 
    );

	// CTA link setting
	$wp_customize->add_setting(
		'emerge_cta_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default' => '#',
		)
	);

	$wp_customize->add_control(
		'emerge_cta_link',
		array(
			'section'		=> 'emerge_cta',
			'label'			=> esc_html__( 'Link:', 'emerge-pro' ),
			'type'			=> 'url',
			'active_callback' => 'emerge_if_cta_custom'
		)
	);

	/**
	 * Services section
	 */
	// Services section
	$wp_customize->add_section(
		'emerge_services',
		array(
			'title' => esc_html__( 'Services', 'emerge-pro' ),
			'description'			=> __( 'The content from post, page and category is trimmed to 15 words.', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Services enable settings
	$wp_customize->add_setting(
		'emerge_services',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_services',
		array(
			'section'		=> 'emerge_services',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'cat' => esc_html__( 'Category', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Services title setting
	$wp_customize->add_setting(
		'emerge_services_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_services_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_services_title',
		array(
			'section'		=> 'emerge_services',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_services_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_services_title', 
		array(
	        'selector'            => '#our-services .section-title',
			'render_callback'     => 'emerge_services_partial_title',
    	) 
    );

    // Services sub title setting
	$wp_customize->add_setting(
		'emerge_services_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_services_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_services_sub_title',
		array(
			'section'		=> 'emerge_services',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_services_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_services_sub_title', 
		array(
	        'selector'            => '#our-services .section-subtitle',
			'render_callback'     => 'emerge_services_partial_sub_title',
    	) 
    );

    // Services number setting
	$wp_customize->add_setting(
		'emerge_services_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 6,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_services_num',
		array(
			'section'		=> 'emerge_services',
			'label'			=> esc_html__( 'Number of services:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 12', 'emerge-pro' ),
			'active_callback' => 'emerge_if_services_not_disabled',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 3, 'max' =>12 ),
		)
	);

	// Services number separator setting
	$wp_customize->add_setting(
		'emerge_services_num_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_services_num_separator',
			array(
				'section'		=> 'emerge_services',
				'active_callback' => 'emerge_if_services_not_disabled',
				'type'			=> 'emerge-separator',
			)
		)
	);

    // Services category setting
	$wp_customize->add_setting(
		'emerge_services_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
		)
	);

	$wp_customize->add_control(
		'emerge_services_cat',
		array(
			'section'		=> 'emerge_services',
			'label'			=> esc_html__( 'Category:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_services_cat',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_cat_choices(),
		)
	);

	$services_num = get_theme_mod( 'emerge_services_num', 6 );
	for ( $i=1; $i <= $services_num; $i++ ) { 
			// Services custom title setting
		$wp_customize->add_setting(
			'emerge_services_custom_title_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => $default['emerge_services_custom_title'],
			)
		);

		$wp_customize->add_control(
			'emerge_services_custom_title_' . $i,
			array(
				'section'		=> 'emerge_services',
				'label'			=> esc_html__( 'Title ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_services_custom'
			)
		);

	    // Services custom content setting
		$wp_customize->add_setting(
			'emerge_services_custom_content_' . $i,
			array(
				'sanitize_callback' => 'sanitize_textarea_field',
				'default' => $default['emerge_services_custom_content'],
			)
		);

		$wp_customize->add_control(
			'emerge_services_custom_content_' . $i,
			array(
				'section'		=> 'emerge_services',
				'label'			=> esc_html__( 'Content ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_services_custom',
				'type'			=> 'textarea'
			)
		);

		// Services custom image setting
		$wp_customize->add_setting(
			'emerge_services_image_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_image',
				'default'		=> $default['emerge_services_image'],
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				'emerge_services_image_' . $i,
				array(
					'section'		=> 'emerge_services',
					'label'			=> esc_html__( 'Image ', 'emerge-pro' ) . $i,
					'active_callback' => 'emerge_if_services_custom',
				)
			)
		);

		// Services custom link setting
		$wp_customize->add_setting(
			'emerge_services_link_' . $i,
			array(
				'sanitize_callback' => 'esc_url_raw',
				'default'		=> '#',
			)
		);

		$wp_customize->add_control(
			'emerge_services_link_' . $i,
			array(
				'section'		=> 'emerge_services',
				'label'			=> esc_html__( 'Link ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_services_custom',
				'type'			=> 'url',
			)
		);

		// Services separator setting
		$wp_customize->add_setting(
			'emerge_services_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_services_separator_' . $i,
				array(
					'section'		=> 'emerge_services',
					'active_callback' => 'emerge_if_services_custom',
					'type'			=> 'emerge-separator',
				)
			)
		);

		// Services post setting
		$wp_customize->add_setting(
			'emerge_services_post_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_services_post_' . $i,
			array(
				'section'		=> 'emerge_services',
				'label'			=> esc_html__( 'Post ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_services_post',
				'type'			=> 'select',
				'choices'		=> emerge_get_post_choices(),
			)
		);

		// Services page setting
		$wp_customize->add_setting(
			'emerge_services_page_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_services_page_' . $i,
			array(
				'section'		=> 'emerge_services',
				'label'			=> esc_html__( 'Page ', 'emerge-pro' ) . $i,
				'type'			=> 'dropdown-pages',
				'active_callback' => 'emerge_if_services_page'
			)
		);
	}

	/**
	 * Video section
	 */
	// Video section
	$wp_customize->add_section(
		'emerge_video',
		array(
			'title' => esc_html__( 'Video', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Video enable settings
	$wp_customize->add_setting(
		'emerge_video_enable',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true
		)
	);

	$wp_customize->add_control(
		'emerge_video_enable',
		array(
			'section'		=> 'emerge_video',
			'label'			=> esc_html__( 'Enable video.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Video link settings
	$wp_customize->add_setting(
		'emerge_video_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default' => 'https://youtu.be/668nUCeBHyY'
		)
	);

	$wp_customize->add_control(
		'emerge_video_link',
		array(
			'section'		=> 'emerge_video',
			'label'			=> esc_html__( 'Video link:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_video_enable',
			'type'			=> 'url',
		)
	);

	/**
	 * Reasons section
	 */
	// Reasons section
	$wp_customize->add_section(
		'emerge_reasons',
		array(
			'title' => esc_html__( 'Reasons', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Reasons enable settings
	$wp_customize->add_setting(
		'emerge_reasons_enable',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_enable',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Enable reasons.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Reasons title setting
	$wp_customize->add_setting(
		'emerge_reasons_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_reasons_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_title',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_enable'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_reasons_title', 
		array(
	        'selector'            => '#reasons .section-title',
			'render_callback'     => 'emerge_reasons_partial_title',
    	) 
    );

    // Reasons sub title setting
	$wp_customize->add_setting(
		'emerge_reasons_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_reasons_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_sub_title',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_enable'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_reasons_sub_title', 
		array(
	        'selector'            => '#reasons .section-subtitle',
			'render_callback'     => 'emerge_reasons_partial_sub_title',
    	) 
    );

	// Reasons separator setting
	$wp_customize->add_setting(
		'emerge_reasons_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_reasons_separator',
			array(
				'section'		=> 'emerge_reasons',
				'active_callback' => 'emerge_if_reasons_enable',
				'type'			=> 'emerge-separator',
			)
		)
	);

	// Reasons content settings
	$wp_customize->add_setting(
		'emerge_reasons_content',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_content',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Left content type:', 'emerge-pro' ),
			'type'			=> 'select',
			'active_callback' => 'emerge_if_reasons_enable',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Reasons post setting
	$wp_customize->add_setting(
		'emerge_reasons_post',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_post',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Post', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_post',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_choices(),
		)
	);

	// Reasons page setting
	$wp_customize->add_setting(
		'emerge_reasons_page',
		array(
			'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_page',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Page', 'emerge-pro' ),
			'type'			=> 'dropdown-pages',
			'active_callback' => 'emerge_if_reasons_page'
		)
	);

	// Reasons custom content setting
	$wp_customize->add_setting(
		'emerge_reasons_custom_content',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
			'default' => $default['emerge_reasons_custom_content'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_custom_content',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Content ', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_custom',
			'type'			=> 'textarea'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
	'emerge_reasons_custom_content', 
	array(
	        'selector'            => '#reasons .entry-content p',
			'render_callback'     => 'emerge_reasons_partial_custom_content',
    	) 
    );

	// Reasons btn text setting
	$wp_customize->add_setting(
		'emerge_reasons_custom_btn_txt',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
			'default' => esc_html__( 'Read More', 'emerge-pro' ),
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_custom_btn_txt',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Button text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_left_not_disable',
		)
	);

	$wp_customize->selective_refresh->add_partial( 
	'emerge_reasons_custom_btn_txt', 
	array(
	        'selector'            => '#reasons .read-more a',
			'render_callback'     => 'emerge_reasons_partial_custom_btn_text',
    	) 
    );

	// Reasons custom link setting
	$wp_customize->add_setting(
		'emerge_reasons_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default'		=> '#',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_link',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Link ', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_custom',
			'type'			=> 'url',
		)
	);

	// Reasons left separator setting
	$wp_customize->add_setting(
		'emerge_reasons_left_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_reasons_left_separator',
			array(
				'section'		=> 'emerge_reasons',
				'active_callback' => 'emerge_if_reasons_left_not_disable',
				'type'			=> 'emerge-separator',
			)
		)
	);

	// Reasons skill enable settings
	$wp_customize->add_setting(
		'emerge_reasons_skill_enable',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_skill_enable',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Enable skills.', 'emerge-pro' ),
			'type'			=> 'checkbox',
			'active_callback' => 'emerge_if_reasons_enable'
		)
	);

    // Reasons number setting
	$wp_customize->add_setting(
		'emerge_reasons_skill_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 4,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_reasons_skill_num',
		array(
			'section'		=> 'emerge_reasons',
			'label'			=> esc_html__( 'Number of skills:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 12', 'emerge-pro' ),
			'active_callback' => 'emerge_if_reasons_skill_enable',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' => 12 ),
		)
	);

	$skill_num = get_theme_mod( 'emerge_reasons_skill_num', 4 );
	for ( $j=1; $j <= $skill_num; $j++ ) { 
		// Reasons skill title setting
		$wp_customize->add_setting(
			'emerge_reasons_skill_title_' . $j,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => esc_html__( 'Management', 'emerge-pro' ),
			)
		);

		$wp_customize->add_control(
			'emerge_reasons_skill_title_' . $j,
			array(
				'section'		=> 'emerge_reasons',
				'label'			=> esc_html__( 'Title ', 'emerge-pro' ) . $j,
				'active_callback' => 'emerge_if_reasons_skill_enable'
			)
		);

		// Reasons skill percentage setting
		$wp_customize->add_setting(
			'emerge_reasons_skill_value_' . $j,
			array(
				'sanitize_callback' => 'emerge_sanitize_number_range',
				'default' => 40,
			)
		);

		$wp_customize->add_control(
			'emerge_reasons_skill_value_' . $j,
			array(
				'section'		=> 'emerge_reasons',
				'label'			=> esc_html__( 'Value ', 'emerge-pro' ) . $j,
				'description'			=> esc_html__( 'Value is in percentage( % )', 'emerge-pro' ),
				'active_callback' => 'emerge_if_reasons_skill_enable',
				'type'			=> 'number',
				'input_attrs'	=> array( 'min' => 1, 'max' =>100 ),
			)
		);

		// Reasons skill color setting
		$wp_customize->add_setting(
			'emerge_reasons_skill_color_' . $j,
			array(
				'sanitize_callback' => 'emerge_sanitize_hex_color',
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Color_Control( 
				$wp_customize, 
				'emerge_reasons_skill_color_' . $j,
				array(
					'section'		=> 'emerge_reasons',
					'label'			=> esc_html__( 'Color ', 'emerge-pro' ) . $j,
					'active_callback' => 'emerge_if_reasons_skill_enable',
				) 
			)
		);

		// Reasons skill separator setting
		$wp_customize->add_setting(
			'emerge_reasons_skill_separator_' . $j,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_reasons_skill_separator_' . $j,
				array(
					'section'		=> 'emerge_reasons',
					'active_callback' => 'emerge_if_reasons_skill_enable',
					'type'			=> 'emerge-separator',
				)
			)
		);
	}
	/**
	 * Team section
	 */
	// Team section
	$wp_customize->add_section(
		'emerge_team',
		array(
			'title' => esc_html__( 'Team', 'emerge-pro' ),
			'description' => esc_html__( 'Images from posts or pages is cropped to 400px by 400px. So it is recommended to upload images of 400px by 400px or 1:1 ratio.', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Team enable settings
	$wp_customize->add_setting(
		'emerge_team',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_team',
		array(
			'section'		=> 'emerge_team',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'cat' => esc_html__( 'Category', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Team title setting
	$wp_customize->add_setting(
		'emerge_team_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_team_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_team_title',
		array(
			'section'		=> 'emerge_team',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_team_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_team_title', 
		array(
	        'selector'            => '#our-team .section-title',
			'render_callback'     => 'emerge_team_partial_title',
		) 
	);

	// Team sub title setting
	$wp_customize->add_setting(
		'emerge_team_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_team_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_team_sub_title',
		array(
			'section'		=> 'emerge_team',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_team_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_team_sub_title', 
		array(
	        'selector'            => '#our-team .section-subtitle',
			'render_callback'     => 'emerge_team_partial_sub_title',
		) 
	);

	// Team title separator setting
	$wp_customize->add_setting(
		'emerge_team_title_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_team_title_separator',
			array(
				'section'		=> 'emerge_team',
				'active_callback' => 'emerge_if_team_not_disabled',
				'type'			=> 'emerge-separator',
			)
		)
	);

	// Team number setting
	$wp_customize->add_setting(
		'emerge_team_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 4,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_team_num',
		array(
			'section'		=> 'emerge_team',
			'label'			=> esc_html__( 'Number of team:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 12', 'emerge-pro' ),
			'active_callback' => 'emerge_if_team_not_disabled',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' =>12 ),
		)
	);

	// Team number separator setting
	$wp_customize->add_setting(
		'emerge_team_num_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_team_num_separator',
			array(
				'section'		=> 'emerge_team',
				'active_callback' => 'emerge_if_team_not_disabled',
				'type'			=> 'emerge-separator',
			)
		)
	);

	// Team category setting
	$wp_customize->add_setting(
		'emerge_team_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
		)
	);

	$wp_customize->add_control(
		'emerge_team_cat',
		array(
			'section'		=> 'emerge_team',
			'label'			=> esc_html__( 'Category:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_team_cat',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_cat_choices(),
		)
	);

	$team_num = get_theme_mod( 'emerge_team_num', 4 );
	for ( $i=1; $i <= $team_num; $i++ ) { 
		// Team custom title setting
		$wp_customize->add_setting(
			'emerge_team_custom_title_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => $default['emerge_team_custom_title'],
			)
		);

		$wp_customize->add_control(
			'emerge_team_custom_title_' . $i,
			array(
				'section'		=> 'emerge_team',
				'label'			=> esc_html__( 'Name ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_team_custom'
			)
		);

		// Team custom position setting
		$wp_customize->add_setting(
			'emerge_team_custom_position_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => $default['emerge_team_custom_position'],
			)
		);

		$wp_customize->add_control(
			'emerge_team_custom_position_' . $i,
			array(
				'section'		=> 'emerge_team',
				'label'			=> esc_html__( 'Position ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_team_not_disabled'
			)
		);

		// Team custom image setting
		$wp_customize->add_setting(
			'emerge_team_image_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_image',
				'default'		=> $default['emerge_team_image'],
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				'emerge_team_image_' . $i,
				array(
					'section'		=> 'emerge_team',
					'label'			=> esc_html__( 'Image ', 'emerge-pro' ) . $i,
					'active_callback' => 'emerge_if_team_custom',
				)
			)
		);

		// Team custom team link setting
		$wp_customize->add_setting(
			'emerge_team_link_' . $i,
			array(
				'sanitize_callback' => 'esc_url_raw',
				'default'		=> '#',
			)
		);

		$wp_customize->add_control(
			'emerge_team_link_' . $i,
			array(
				'section'		=> 'emerge_team',
				'label'			=> esc_html__( 'Team Link ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_team_custom',
				'type'			=> 'url',
			)
		);

		// Team post setting
		$wp_customize->add_setting(
			'emerge_team_post_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_team_post_' . $i,
			array(
				'section'		=> 'emerge_team',
				'label'			=> esc_html__( 'Post ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_team_post',
				'type'			=> 'select',
				'choices'		=> emerge_get_post_choices(),
			)
		);

		// Team page setting
		$wp_customize->add_setting(
			'emerge_team_page_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_team_page_' . $i,
			array(
				'section'		=> 'emerge_team',
				'label'			=> esc_html__( 'Page ', 'emerge-pro' ) . $i,
				'type'			=> 'dropdown-pages',
				'active_callback' => 'emerge_if_team_page'
			)
		);

		for ( $j=1; $j <=	 3; $j++ ) { 
			// Team custom social link setting
			$wp_customize->add_setting(
				'emerge_team_social_link_' . $j . '_' . $i,
				array(
					'sanitize_callback' => 'esc_url_raw',
					'default'		=> 'https://facebook.com',
				)
			);

			$wp_customize->add_control(
				'emerge_team_social_link_' . $j . '_' . $i,
				array(
					'section'		=> 'emerge_team',
					'label'			=> esc_html__( 'Social Link ', 'emerge-pro' ) . $j,
					'active_callback' => 'emerge_if_team_not_disabled',
					'type'			=> 'url',
				)
			);
		}

		// Team title separator setting
		$wp_customize->add_setting(
			'emerge_team_post_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_team_post_separator_' . $i,
				array(
					'section'		=> 'emerge_team',
					'active_callback' => 'emerge_if_team_not_disabled',
					'type'			=> 'emerge-separator',
				)
			)
		);
	}

	/**
	 * Portfolio section
	 */
	// Portfolio section
	$wp_customize->add_section(
		'emerge_portfolio',
		array(
			'title' => esc_html__( 'Portfolio', 'emerge-pro' ),
			'description'			=> __( 'The content from post and page is trimmed to 15 words.<b>Please note that posts with no featured image will not be displayed.</b>', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Portfolio enable settings
	$wp_customize->add_setting(
		'emerge_portfolio',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'cat' => esc_html__( 'Category', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Portfolio title setting
	$wp_customize->add_setting(
		'emerge_portfolio_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_portfolio_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_title',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_portfolio_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_portfolio_title', 
		array(
	        'selector'            => '#latest-portfolios .section-title',
			'render_callback'     => 'emerge_portfolio_partial_title',
    	) 
    );

    // Portfolio sub title setting
	$wp_customize->add_setting(
		'emerge_portfolio_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_portfolio_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_sub_title',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_portfolio_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_portfolio_sub_title', 
		array(
	        'selector'            => '#latest-portfolios .section-subtitle',
			'render_callback'     => 'emerge_portfolio_partial_sub_title',
    	) 
    );


	// Portfolio button text setting
	$wp_customize->add_setting(
		'emerge_portfolio_btn_txt',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => esc_html__( 'Show More', 'emerge-pro' ),
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_btn_txt',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Button Text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_portfolio_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_portfolio_btn_txt', 
		array(
	        'selector'            => '#latest-portfolios .load-more a',
			'render_callback'     => 'emerge_portfolio_partial_btn_txt',
    	) 
    );

	// Portfolio link setting
	$wp_customize->add_setting(
		'emerge_portfolio_link',
		array(
			'sanitize_callback' => 'esc_url_raw',
			'default' => '#',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_link',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Button Link:', 'emerge-pro' ),
			'type'			=> 'url',
			'active_callback' => 'emerge_if_portfolio_not_cat_disabled'
		)
	);

    // Portfolio number setting
	$wp_customize->add_setting(
		'emerge_portfolio_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 6,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_num',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Number of portfolios:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 3 | Max: 6', 'emerge-pro' ),
			'active_callback' => 'emerge_if_portfolio_not_disabled',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 3, 'max' => 6 ),
		)
	);

    // Portfolio category setting
	$wp_customize->add_setting(
		'emerge_portfolio_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
		)
	);

	$wp_customize->add_control(
		'emerge_portfolio_cat',
		array(
			'section'		=> 'emerge_portfolio',
			'label'			=> esc_html__( 'Category:', 'emerge-pro' ),
			'description'			=> esc_html__( 'The button will be linked to the selected category\'s archive link automatically.', 'emerge-pro' ),
			'active_callback' => 'emerge_if_portfolio_cat',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_cat_choices(),
		)
	);

	$portfolio_num = get_theme_mod( 'emerge_portfolio_num', 6 );
	for ( $i=1; $i <= $portfolio_num; $i++ ) { 
			// Portfolio custom title setting
		$wp_customize->add_setting(
			'emerge_portfolio_custom_title_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => $default['emerge_portfolio_custom_title'],
			)
		);

		$wp_customize->add_control(
			'emerge_portfolio_custom_title_' . $i,
			array(
				'section'		=> 'emerge_portfolio',
				'label'			=> esc_html__( 'Title ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_portfolio_custom'
			)
		);

	    // Portfolio custom content setting
		$wp_customize->add_setting(
			'emerge_portfolio_custom_content_' . $i,
			array(
				'sanitize_callback' => 'sanitize_textarea_field',
				'default' => $default['emerge_portfolio_custom_content'],
			)
		);

		$wp_customize->add_control(
			'emerge_portfolio_custom_content_' . $i,
			array(
				'section'		=> 'emerge_portfolio',
				'label'			=> esc_html__( 'Content ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_portfolio_custom',
				'type'			=> 'textarea'
			)
		);

		// Portfolio custom image setting
		$wp_customize->add_setting(
			'emerge_portfolio_image_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_image',
				'default'		=> $default['emerge_portfolio_image'],
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				'emerge_portfolio_image_' . $i,
				array(
					'section'		=> 'emerge_portfolio',
					'label'			=> esc_html__( 'Image ', 'emerge-pro' ) . $i,
					'active_callback' => 'emerge_if_portfolio_custom',
				)
			)
		);

		// Portfolio custom link setting
		$wp_customize->add_setting(
			'emerge_portfolio_link_' . $i,
			array(
				'sanitize_callback' => 'esc_url_raw',
				'default'		=> '#',
			)
		);

		$wp_customize->add_control(
			'emerge_portfolio_link_' . $i,
			array(
				'section'		=> 'emerge_portfolio',
				'label'			=> esc_html__( 'Link ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_portfolio_custom',
				'type'			=> 'url',
			)
		);

		// Portfolio custom separator setting
		$wp_customize->add_setting(
			'emerge_portfolio_custom_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_portfolio_custom_separator_' . $i,
				array(
					'section'		=> 'emerge_portfolio',
					'active_callback' => 'emerge_if_portfolio_custom',
					'type'			=> 'emerge-separator',
				)
			)
		);

		// Portfolio post setting
		$wp_customize->add_setting(
			'emerge_portfolio_post_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_portfolio_post_' . $i,
			array(
				'section'		=> 'emerge_portfolio',
				'label'			=> esc_html__( 'Post ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_portfolio_post',
				'type'			=> 'select',
				'choices'		=> emerge_get_post_choices(),
			)
		);

		// Portfolio page setting
		$wp_customize->add_setting(
			'emerge_portfolio_page_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_portfolio_page_' . $i,
			array(
				'section'		=> 'emerge_portfolio',
				'label'			=> esc_html__( 'Page ', 'emerge-pro' ) . $i,
				'type'			=> 'dropdown-pages',
				'active_callback' => 'emerge_if_portfolio_page'
			)
		);
	}

	/**
	 * Counter section
	 */
	// Counter section
	$wp_customize->add_section(
		'emerge_counter',
		array(
			'title' => esc_html__( 'Counter', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Counter enable setting
	$wp_customize->add_setting(
		'emerge_enable_counter',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_counter',
		array(
			'section'		=> 'emerge_counter',
			'label'			=> esc_html__( 'Enable counter.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Counter number setting
	$wp_customize->add_setting(
		'emerge_counter_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 4,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_counter_num',
		array(
			'section'		=> 'emerge_counter',
			'label'			=> esc_html__( 'Number of counters:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 4', 'emerge-pro' ),
			'active_callback' => 'emerge_if_counter_enable',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' => 4 ),
		)
	);

	$counter_num = get_theme_mod( 'emerge_counter_num', 4 );
	for ( $i=1; $i <= $counter_num; $i++ ) { 
		$count_default = 30 + 10 * $i;
		// Counter title setting
		$wp_customize->add_setting(
			'emerge_counter_title_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => esc_html__( 'Working Hours', 'emerge-pro' ),
			)
		);

		$wp_customize->add_control(
			'emerge_counter_title_' . $i,
			array(
				'section'		=> 'emerge_counter',
				'label'			=> esc_html__( 'Title ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_counter_enable'
			)
		);

		// Counter count setting
		$wp_customize->add_setting(
			'emerge_counter_count_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_number_range',
				'default' => $count_default,
			)
		);

		$wp_customize->add_control(
			'emerge_counter_count_' . $i,
			array(
				'section'		=> 'emerge_counter',
				'label'			=> esc_html__( 'Count ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_counter_enable',
				'type'			=> 'number',
				'input_attrs'	=> array( 'min' => 1 ),
			)
		);

		// Counter separator setting
		$wp_customize->add_setting(
			'emerge_counter_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_counter_separator_' . $i,
				array(
					'section'		=> 'emerge_counter',
					'active_callback' => 'emerge_if_counter_enable',
					'type'			=> 'emerge-separator',
				)
			)
		);
	}

	/**
	 * Testimonial section
	 */
	// Testimonial section
	$wp_customize->add_section(
		'emerge_testimonial',
		array(
			'title' => esc_html__( 'Testimonial', 'emerge-pro' ),
			'description'			=> __( 'The content from post, page and category is trimmed to 15 words.', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Testimonial enable settings
	$wp_customize->add_setting(
		'emerge_testimonial',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'custom'
		)
	);

	$wp_customize->add_control(
		'emerge_testimonial',
		array(
			'section'		=> 'emerge_testimonial',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
					'page' => esc_html__( 'Page', 'emerge-pro' ),
					'cat' => esc_html__( 'Category', 'emerge-pro' ),
					'custom' => esc_html__( 'Custom', 'emerge-pro' ),
			 	)
		)
	);

	// Testimonial title setting
	$wp_customize->add_setting(
		'emerge_testimonial_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_testimonial_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_testimonial_title',
		array(
			'section'		=> 'emerge_testimonial',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_testimonial_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_testimonial_title', 
		array(
	        'selector'            => '#testimonial .section-title',
			'render_callback'     => 'emerge_testimonial_partial_title',
		) 
	);

	// Testimonial sub title setting
	$wp_customize->add_setting(
		'emerge_testimonial_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_testimonial_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_testimonial_sub_title',
		array(
			'section'		=> 'emerge_testimonial',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_testimonial_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_testimonial_sub_title', 
		array(
	        'selector'            => '#testimonial .section-subtitle',
			'render_callback'     => 'emerge_testimonial_partial_sub_title',
		) 
	);

	// Testimonial number setting
	$wp_customize->add_setting(
		'emerge_testimonial_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 3,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_testimonial_num',
		array(
			'section'		=> 'emerge_testimonial',
			'label'			=> esc_html__( 'Number of testimonial:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 9', 'emerge-pro' ),
			'active_callback' => 'emerge_if_testimonial_not_disabled',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' => 9 ),
		)
	);

	// Testimonial number separator setting
	$wp_customize->add_setting(
		'emerge_testimonial_num_separator',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
		)
	);

	$wp_customize->add_control(
		new Emerge_Separator_Custom_Control( 
		$wp_customize,
		'emerge_testimonial_num_separator',
			array(
				'section'		=> 'emerge_testimonial',
				'active_callback' => 'emerge_if_testimonial_not_disabled',
				'type'			=> 'emerge-separator',
			)
		)
	);

	// Testimonial category setting
	$wp_customize->add_setting(
		'emerge_testimonial_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
		)
	);

	$wp_customize->add_control(
		'emerge_testimonial_cat',
		array(
			'section'		=> 'emerge_testimonial',
			'label'			=> esc_html__( 'Category:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_testimonial_cat',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_cat_choices(),
		)
	);

	$testimonial_num = get_theme_mod( 'emerge_testimonial_num', 3 );
	for ( $i=1; $i <= $testimonial_num; $i++ ) { 
		// Testimonial custom image setting
		$wp_customize->add_setting(
			'emerge_testimonial_image_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_image',
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				'emerge_testimonial_image_' . $i,
				array(
					'section'		=> 'emerge_testimonial',
					'label'			=> esc_html__( 'Image ', 'emerge-pro' ) . $i,
					'active_callback' => 'emerge_if_testimonial_custom',
				)
			)
		);

	    // Testimonial custom content setting
		$wp_customize->add_setting(
			'emerge_testimonial_custom_content_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
				'default' => $default['emerge_testimonial_custom_content'],
			)
		);

		$wp_customize->add_control(
			'emerge_testimonial_custom_content_' . $i,
			array(
				'section'		=> 'emerge_testimonial',
				'label'			=> esc_html__( 'Content ', 'emerge-pro' ) . $i,
				'description'			=> esc_html__( 'HTML Allowed ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_testimonial_custom',
				'type'			=> 'textarea'
			)
		);

		// Testimonial custom name setting
		$wp_customize->add_setting(
			'emerge_testimonial_custom_name_' . $i,
			array(
				'sanitize_callback' => 'sanitize_text_field',
				'default' => $default['emerge_testimonial_custom_name'],
			)
		);

		$wp_customize->add_control(
			'emerge_testimonial_custom_name_' . $i,
			array(
				'section'		=> 'emerge_testimonial',
				'label'			=> esc_html__( 'Title ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_testimonial_custom'
			)
		);

		// Testimonial custom separator setting
		$wp_customize->add_setting(
			'emerge_testimonial_custom_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_testimonial_custom_separator_' . $i,
				array(
					'section'		=> 'emerge_testimonial',
					'active_callback' => 'emerge_if_testimonial_custom',
					'type'			=> 'emerge-separator',
				)
			)
		);

		// Testimonial post setting
		$wp_customize->add_setting(
			'emerge_testimonial_post_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_testimonial_post_' . $i,
			array(
				'section'		=> 'emerge_testimonial',
				'label'			=> esc_html__( 'Post ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_testimonial_post',
				'type'			=> 'select',
				'choices'		=> emerge_get_post_choices(),
			)
		);

		// Testimonial page setting
		$wp_customize->add_setting(
			'emerge_testimonial_page_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_testimonial_page_' . $i,
			array(
				'section'		=> 'emerge_testimonial',
				'label'			=> esc_html__( 'Page ', 'emerge-pro' ) . $i,
				'type'			=> 'dropdown-pages',
				'active_callback' => 'emerge_if_testimonial_page'
			)
		);
	}

	/**
	 * Partner section
	 */
	// Partner section
	$wp_customize->add_section(
		'emerge_partner',
		array(
			'title' => esc_html__( 'Partner', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Partner enable setting
	$wp_customize->add_setting(
		'emerge_enable_partner',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_partner',
		array(
			'section'		=> 'emerge_partner',
			'label'			=> esc_html__( 'Enable partner.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Partner number setting
	$wp_customize->add_setting(
		'emerge_partner_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 4,
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_partner_num',
		array(
			'section'		=> 'emerge_partner',
			'label'			=> esc_html__( 'Number of partners:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 10', 'emerge-pro' ),
			'active_callback' => 'emerge_if_partner_enable',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' => 10 ),
		)
	);

	$partner_num = get_theme_mod( 'emerge_partner_num', 4 );
	for ( $i=1; $i <= $partner_num; $i++ ) { 
		// Testimonial custom image setting
		$wp_customize->add_setting(
			'emerge_partner_logo_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_image',
			)
		);

		$wp_customize->add_control(
			new WP_Customize_Image_Control(
				$wp_customize,
				'emerge_partner_logo_' . $i,
				array(
					'section'		=> 'emerge_partner',
					'label'			=> esc_html__( 'Partner logo ', 'emerge-pro' ) . $i,
					'active_callback' => 'emerge_if_partner_enable',
				)
			)
		);

		// Partner link setting
		$wp_customize->add_setting(
			'emerge_partner_link_' . $i,
			array(
				'sanitize_callback' => 'esc_url_raw',
				'default' => '#',
			)
		);

		$wp_customize->add_control(
			'emerge_partner_link_' . $i,
			array(
				'section'		=> 'emerge_partner',
				'label'			=> esc_html__( 'Partner link ', 'emerge-pro' ) . $i,
				'type'			=> 'url',
				'active_callback' => 'emerge_if_partner_enable'
			)
		);

		// Partner open in new tab settings
		$wp_customize->add_setting(
			'emerge_partner_open_new_tab_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_checkbox',
				'default' => true
			)
		);

		$wp_customize->add_control(
			'emerge_partner_open_new_tab_' . $i,
			array(
				'section'		=> 'emerge_partner',
				'label'			=> esc_html__( 'Open in new tab.', 'emerge-pro' ),
				'type'			=> 'checkbox',
				'active_callback' => 'emerge_if_partner_enable'
			)
		);

		// Partner separator setting
		$wp_customize->add_setting(
			'emerge_partner_separator_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_html',
			)
		);

		$wp_customize->add_control(
			new Emerge_Separator_Custom_Control( 
			$wp_customize,
			'emerge_partner_separator_' . $i,
				array(
					'section'		=> 'emerge_partner',
					'active_callback' => 'emerge_if_partner_enable',
					'type'			=> 'emerge-separator',
				)
			)
		);
	}

	/**
	 * Blog section section
	 */
	// Blog section section
	$wp_customize->add_section(
		'emerge_blog_section',
		array(
			'title' => esc_html__( 'Blog section', 'emerge-pro' ),
			'description' => esc_html__( 'Images will be cropped and displayed in 400px by 300px. The recommended size for this section is 400px by 300px.', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Blog section enable settings
	$wp_customize->add_setting(
		'emerge_blog_section',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'recent-posts'
		)
	);

	$wp_customize->add_control(
		'emerge_blog_section',
		array(
			'section'		=> 'emerge_blog_section',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Choose where you want to render the content from.', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
					'recent-posts' => esc_html__( 'Recent Posts', 'emerge-pro' ),
					'cat' => esc_html__( 'Category', 'emerge-pro' ),
					'post' => esc_html__( 'Post', 'emerge-pro' ),
			 	)
		)
	);

	// Blog section title setting
	$wp_customize->add_setting(
		'emerge_blog_section_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_blog_section_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_blog_section_title',
		array(
			'section'		=> 'emerge_blog_section',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_blog_section_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_blog_section_title', 
		array(
	        'selector'            => '#latest-posts .section-title',
			'render_callback'     => 'emerge_blog_section_partial_title',
    	) 
    );

    // Blog section sub title setting
	$wp_customize->add_setting(
		'emerge_blog_section_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_blog_section_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_blog_section_sub_title',
		array(
			'section'		=> 'emerge_blog_section',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_blog_section_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_blog_section_sub_title', 
		array(
	        'selector'            => '#latest-posts .section-subtitle',
			'render_callback'     => 'emerge_blog_section_partial_sub_title',
    	) 
    );

    // Blog section number setting
	$wp_customize->add_setting(
		'emerge_blog_section_num',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 3,
			// 'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_blog_section_num',
		array(
			'section'		=> 'emerge_blog_section',
			'label'			=> esc_html__( 'Number of posts:', 'emerge-pro' ),
			'description'			=> esc_html__( 'Min: 1 | Max: 6', 'emerge-pro' ),
			'active_callback' => 'emerge_if_blog_section_not_disabled',
			'type'			=> 'number',
			'input_attrs'	=> array( 'min' => 1, 'max' => 6 ),
		)
	);

	// Blog section category setting
	$wp_customize->add_setting(
		'emerge_blog_section_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
		)
	);

	$wp_customize->add_control(
		'emerge_blog_section_cat',
		array(
			'section'		=> 'emerge_blog_section',
			'label'			=> esc_html__( 'Category:', 'emerge-pro' ),
			'description'			=> esc_html__( 'The button will be linked to the selected category\'s archive link automatically.', 'emerge-pro' ),
			'active_callback' => 'emerge_if_blog_section_cat',
			'type'			=> 'select',
			'choices'		=> emerge_get_post_cat_choices(),
		)
	);

	$emerge_blog_section_num = get_theme_mod( 'emerge_blog_section_num', 3 );
	for ( $i=1; $i <= $emerge_blog_section_num; $i++ ) { 
		// Portfolio post setting
		$wp_customize->add_setting(
			'emerge_blog_section_post_' . $i,
			array(
				'sanitize_callback' => 'emerge_sanitize_dropdown_pages',
			)
		);

		$wp_customize->add_control(
			'emerge_blog_section_post_' . $i,
			array(
				'section'		=> 'emerge_blog_section',
				'label'			=> esc_html__( 'Post ', 'emerge-pro' ) . $i,
				'active_callback' => 'emerge_if_blog_section_post',
				'type'			=> 'select',
				'choices'		=> emerge_get_post_choices(),
			)
		);
	}

	/**
	 * Subscription section
	 */
	// Subscription section
	$wp_customize->add_section(
		'emerge_subscribe',
		array(
			'title' => esc_html__( 'Subscription', 'emerge-pro' ),
			'description' => sprintf( esc_html__( '%1$sJetpack%2$s should be active and site should be connected to WordPress.com for this section to work.', 'emerge-pro' ), '<a target="_blank" href="https://wordpress.org/plugins/jetpack">', '</a>' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Subscription enable setting
	$wp_customize->add_setting(
		'emerge_enable_subscribe',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_subscribe',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Enable subscribe.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Subscribe title setting
	$wp_customize->add_setting(
		'emerge_subscribe_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_subscribe_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_subscribe_title',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_subscribe_enable'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_subscribe_title', 
		array(
	        'selector'            => '#subscribe-us .widgettitle',
			'render_callback'     => 'emerge_subscribe_partial_title',
		) 
	);

	// Subscribe text setting
	$wp_customize->add_setting(
		'emerge_subscribe_text',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_subscribe_text'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_subscribe_text',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Description:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_subscribe_enable',
			'type'			=> 'textarea'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_subscribe_text', 
		array(
	        'selector'            => '#subscribe-us #subscribe-text p',
			'render_callback'     => 'emerge_subscribe_partial_text',
		) 
	);

	// Subscribe placeholder setting
	$wp_customize->add_setting(
		'emerge_subscribe_placeholder',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_subscribe_placeholder'],
		)
	);

	$wp_customize->add_control(
		'emerge_subscribe_placeholder',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Placeholder text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_subscribe_enable'
		)
	);

	// Subscribe button text setting
	$wp_customize->add_setting(
		'emerge_subscribe_btn_text',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_subscribe_btn_text'],
		)
	);

	$wp_customize->add_control(
		'emerge_subscribe_btn_text',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Button text:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_subscribe_enable'
		)
	);

	// Subscribe success message setting
	$wp_customize->add_setting(
		'emerge_success_msg',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_success_msg'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_success_msg',
		array(
			'section'		=> 'emerge_subscribe',
			'label'			=> esc_html__( 'Success Message:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_subscribe_enable',
			'type'			=> 'textarea'
		)
	);

	// Subscribe image setting
	$wp_customize->add_setting(
		'emerge_subscribe_bg_image',
		array(
			'sanitize_callback' => 'emerge_sanitize_image',
			'default'		=> $default['emerge_subscribe_bg_image'],
		)
	);

	$wp_customize->add_control(
		new WP_Customize_Image_Control(
			$wp_customize,
			'emerge_subscribe_bg_image',
			array(
				'section'		=> 'emerge_subscribe',
				'label'			=> esc_html__( 'Background image:', 'emerge-pro' ),
				'active_callback' => 'emerge_if_subscribe_enable',
			)
		)
	);

	/**
	 * Pricing section
	 */
	// Pricing section
	$wp_customize->add_section(
		'emerge_pricing',
		array(
			'title' => esc_html__( 'Pricing', 'emerge-pro' ),
			'description' => sprintf( __( '%1$sUse case:%2$s This section uses the %3$sPricing Table Widget Area%4$s. You can manage the pricing tables from this widget area. Drop the %5$sMoral Pricing Table%6$s widget in this widget area.', 'emerge-pro' ), '<strong>', '</strong>', '<a href="" data-open="emerge-pricing-table-area">', '</a>', '<b>', '</b>' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Pricing enable setting
	$wp_customize->add_setting(
		'emerge_enable_pricing',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_pricing',
		array(
			'section'		=> 'emerge_pricing',
			'label'			=> esc_html__( 'Enable pricing.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Pricing title setting
	$wp_customize->add_setting(
		'emerge_pricing_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_pricing_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_pricing_title',
		array(
			'section'		=> 'emerge_pricing',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_pricing_enabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_pricing_title', 
		array(
	        'selector'            => '#pricing .section-title',
			'render_callback'     => 'emerge_pricing_partial_title',
		) 
	);

	// Pricing sub title setting
	$wp_customize->add_setting(
		'emerge_pricing_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_pricing_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_pricing_sub_title',
		array(
			'section'		=> 'emerge_pricing',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_pricing_enabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_pricing_sub_title', 
		array(
	        'selector'            => '#pricing .section-subtitle',
			'render_callback'     => 'emerge_pricing_partial_sub_title',
		) 
	);

	/**
	 * Contact section
	 */
	// Contact section
	$wp_customize->add_section(
		'emerge_contact',
		array(
			'title' => esc_html__( 'Contact', 'emerge-pro' ),
			'panel' => 'emerge_home_panel',
		)
	);

	// Contact enable setting
	$wp_customize->add_setting(
		'emerge_enable_contact',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_contact',
		array(
			'section'		=> 'emerge_contact',
			'label'			=> esc_html__( 'Enable contact.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Contact title setting
	$wp_customize->add_setting(	
		'emerge_contact_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_contact_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_contact_title',
		array(
			'section'		=> 'emerge_contact',
			'label'			=> esc_html__( 'Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_contact_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_contact_title', 
		array(
	        'selector'            => '#contact-form .section-title',
			'render_callback'     => 'emerge_contact_partial_title',
    	) 
    );

    // Contact sub title setting
	$wp_customize->add_setting(
		'emerge_contact_sub_title',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => $default['emerge_contact_sub_title'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_contact_sub_title',
		array(
			'section'		=> 'emerge_contact',
			'label'			=> esc_html__( 'Sub Title:', 'emerge-pro' ),
			'active_callback' => 'emerge_if_contact_not_disabled'
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_contact_sub_title', 
		array(
	        'selector'            => '#contact-form .section-subtitle',
			'render_callback'     => 'emerge_contact_partial_sub_title',
    	) 
    );

    // Contact shortcode setting
	$wp_customize->add_setting(
		'emerge_contact_shortcode',
		array(
			'sanitize_callback' => 'sanitize_textarea_field',
		)
	);

	$wp_customize->add_control(
		'emerge_contact_shortcode',
		array(
			'section'		=> 'emerge_contact',
			'label'			=> esc_html__( 'Contact Shortcode:', 'emerge-pro' ),
			'description'			=> sprintf( esc_html__( 'We recommend %1$s Contact Form 7%2$s for the shortcode.', 'emerge-pro' ), '<a href="" target="_blank">', '</a>' ),
			'active_callback' => 'emerge_if_contact_not_disabled',
			'type'			=> 'textarea',
		)
	);

	/**
	 *
	 * General settings panel
	 * 
	 */
	// General settings panel
	$wp_customize->add_panel(
		'emerge_general_panel',
		array(
			'title' => esc_html__( 'General Settings', 'emerge-pro' ),
			'priority' => 140
		)
	);

	// Header section
	$wp_customize->add_section(
		'emerge_header_section',
		array(
			'title' => esc_html__( 'Header', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	/**
	 * General settings
	 */
	// General settings
	$wp_customize->add_section(
		'emerge_general_section',
		array(
			'title' => esc_html__( 'General', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Breadcrumb enable setting
	$wp_customize->add_setting(
		'emerge_breadcrumb_enable',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_breadcrumb_enable',
		array(
			'section'		=> 'emerge_general_section',
			'label'			=> esc_html__( 'Enable breadcrumb.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Backtop enable setting
	$wp_customize->add_setting(
		'emerge_back_to_top_enable',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_back_to_top_enable',
		array(
			'section'		=> 'emerge_general_section',
			'label'			=> esc_html__( 'Enable Scroll up.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Header menu sticky enable settings
	$wp_customize->add_setting(
		'emerge_make_menu_sticky',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => false
		)
	);

	$wp_customize->add_control(
		'emerge_make_menu_sticky',
		array(
			'section'		=> 'emerge_header_section',
			'label'			=> esc_html__( 'Make menu sticky.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Menu type settings
	$wp_customize->add_setting(
		'emerge_menu_type',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'classic'
		)
	);

	$wp_customize->add_control(
		'emerge_menu_type',
		array(
			'section'		=> 'emerge_header_section',
			'label'			=> esc_html__( 'Primary menu type:', 'emerge-pro' ),
			'type'			=> 'select',
			'choices'		=> array( 
					'modern' => esc_html__( 'Modern', 'emerge-pro' ),
					'classic' => esc_html__( 'Classic', 'emerge-pro' ),
			 	)
		)
	);

	/**
	 * Color scheme
	 */
	// Color scheme
	$wp_customize->add_section(
		'emerge_color_scheme',
		array(
			'title' => esc_html__( 'Color scheme', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Color scheme setting
	$wp_customize->add_setting(
		'emerge_color_scheme',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'lite',
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_color_scheme',
		array(
			'section'		=> 'emerge_color_scheme',
			'label'			=> esc_html__( 'Color scheme:', 'emerge-pro' ),
			'type'			=> 'radio',
			'choices'		=> array( 
				'dark' => esc_html__( 'Dark', 'emerge-pro' ), 
				'lite' => esc_html__( 'Light', 'emerge-pro' ), 
			),
		)
	);

	/**
	 * Global Layout
	 */
	// Global Layout
	$wp_customize->add_section(
		'emerge_global_layout',
		array(
			'title' => esc_html__( 'Global Layout', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Global site layout setting
	$wp_customize->add_setting(
		'emerge_site_layout',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'wide',
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_site_layout',
		array(
			'section'		=> 'emerge_global_layout',
			'label'			=> esc_html__( 'Site layout', 'emerge-pro' ),
			'type'			=> 'radio',
			'choices'		=> array( 
				'box' => esc_html__( 'Boxed', 'emerge-pro' ), 
				'wide' => esc_html__( 'Wide', 'emerge-pro' ), 
			),
		)
	);

	// Global archive layout setting
	$wp_customize->add_setting(
		'emerge_archive_sidebar',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'right',
		)
	);

	$wp_customize->add_control(
		'emerge_archive_sidebar',
		array(
			'section'		=> 'emerge_global_layout',
			'label'			=> esc_html__( 'Archive Sidebar', 'emerge-pro' ),
			'description'			=> esc_html__( 'This options works on all archive pages like: 404, search, date, category, blog and so on.', 'emerge-pro' ),
			'type'			=> 'radio',
			'choices'		=> array( 
				'left' => esc_html__( 'Left', 'emerge-pro' ), 
				'right' => esc_html__( 'Right', 'emerge-pro' ), 
				'no' => esc_html__( 'No Sidebar', 'emerge-pro' ), 
			),
		)
	);

	// Global page layout setting
	$wp_customize->add_setting(
		'emerge_global_page_layout',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'right',
		)
	);

	$wp_customize->add_control(
		'emerge_global_page_layout',
		array(
			'section'		=> 'emerge_global_layout',
			'label'			=> esc_html__( 'Global page sidebar', 'emerge-pro' ),
			'description'			=> esc_html__( 'This options works only on single pages. This setting can be overridden for single page from the metabox too.', 'emerge-pro' ),
			'type'			=> 'radio',
			'choices'		=> array( 
				'left' => esc_html__( 'Left', 'emerge-pro' ), 
				'right' => esc_html__( 'Right', 'emerge-pro' ), 
				'no' => esc_html__( 'No Sidebar', 'emerge-pro' ), 
			),
		)
	);

	// Global post layout setting
	$wp_customize->add_setting(
		'emerge_global_post_layout',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'right',
		)
	);

	$wp_customize->add_control(
		'emerge_global_post_layout',
		array(
			'section'		=> 'emerge_global_layout',
			'label'			=> esc_html__( 'Global post sidebar', 'emerge-pro' ),
			'description'			=> esc_html__( 'This options works only on single posts. This setting can be overridden for single post from the metabox too.', 'emerge-pro' ),
			'type'			=> 'radio',
			'choices'		=> array( 
				'left' => esc_html__( 'Left', 'emerge-pro' ), 
				'right' => esc_html__( 'Right', 'emerge-pro' ), 
				'no' => esc_html__( 'No Sidebar', 'emerge-pro' ), 
			),
		)
	);

	/**
	 * Blog/Archive section 
	 */
	// Blog/Archive section 
	$wp_customize->add_section(
		'emerge_archive_settings',
		array(
			'title' => esc_html__( 'Archive/Blog', 'emerge-pro' ),
			'description' => esc_html__( 'Settings for archive pages including blog page too.', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Archive excerpt setting
	$wp_customize->add_setting(
		'emerge_archive_excerpt',
		array(
			'sanitize_callback' => 'sanitize_text_field',
			'default' => esc_html__( 'View the post', 'emerge-pro' ),
		)
	);

	$wp_customize->add_control(
		'emerge_archive_excerpt',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Excerpt more text:', 'emerge-pro' ),
		)
	);

	// Archive excerpt length setting
	$wp_customize->add_setting(
		'emerge_archive_excerpt_length',
		array(
			'sanitize_callback' => 'emerge_sanitize_number_range',
			'default' => 60,
		)
	);

	$wp_customize->add_control(
		'emerge_archive_excerpt_length',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Excerpt more length:', 'emerge-pro' ),
			'type'			=> 'number',
			'input_attrs'   => array( 'min' => 5 ),
		)
	);

	// Date enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_date',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_date',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable date.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Category enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_cat',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable category.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Tag enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_tag',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_tag',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable tags.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Comment enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_comment',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_comment',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable comment count.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);


	// Author enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_author',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_author',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable author.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Featured image enable setting
	$wp_customize->add_setting(
		'emerge_enable_archive_featured_img',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_featured_img',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Enable featured image.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Content type setting
	$wp_customize->add_setting(
		'emerge_enable_archive_content_type',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'excerpt',
		)
	);

	$wp_customize->add_control(
		'emerge_enable_archive_content_type',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Content type:', 'emerge-pro' ),
			'choices'		=> array(
				'full-content' => esc_html__( 'Full content', 'emerge-pro' ), 
				'excerpt' => esc_html__( 'Excerpt', 'emerge-pro' ), 
			),
			'type'			=> 'radio',
		)
	);

	// Pagination type setting
	$wp_customize->add_setting(
		'emerge_archive_pagination_type',
		array(
			'sanitize_callback' => 'emerge_sanitize_select',
			'default' => 'numeric',
		)
	);

	$archive_pagination_description = '';
	$archive_pagination_choices = array( 
				'disable' => esc_html__( '--Disable--', 'emerge-pro' ),
				'numeric' => esc_html__( 'Numeric', 'emerge-pro' ),
				'older_newer' => esc_html__( 'Older / Newer', 'emerge-pro' ),
			);
	if ( ! class_exists( 'JetPack' ) ) {
		$archive_pagination_description = sprintf( esc_html__( 'We recommend to install %1$sJetpack%2$s and enable %3$sInfinite Scroll%4$s feature for automatic loading of posts.', 'emerge-pro' ), '<a target="_blank" href="http://wordpress.org/plugins/jetpack">', '</a>', '<b>', '</b>' );
	} else {
		$archive_pagination_choices['infinite_scroll'] = esc_html__( 'Infinite Load', 'emerge-pro' );
	}
	$wp_customize->add_control(
		'emerge_archive_pagination_type',
		array(
			'section'		=> 'emerge_archive_settings',
			'label'			=> esc_html__( 'Pagination type:', 'emerge-pro' ),
			'description'			=>  $archive_pagination_description,
			'type'			=> 'select',
			'choices'		=> $archive_pagination_choices,
		)
	);

	/**
	 * Single setting section 
	 */
	// Single setting section 
	$wp_customize->add_section(
		'emerge_single_settings',
		array(
			'title' => esc_html__( 'Single Posts', 'emerge-pro' ),
			'description' => esc_html__( 'Settings for all single posts.', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Date enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_date',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_date',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable date.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Category enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_cat',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_cat',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable category.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Tag enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_tag',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_tag',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable tags.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Comment enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_comment',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_comment',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable comment.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);


	// Author enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_author',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_author',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable author.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Featured image enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_featured_img',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_featured_img',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable featured image.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Pagination enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_pagination',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_pagination',
		array(
			'section'		=> 'emerge_single_settings',
			'label'			=> esc_html__( 'Enable pagination.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	/**
	 * Single pages setting section 
	 */
	// Single pages setting section 
	$wp_customize->add_section(
		'emerge_single_page_settings',
		array(
			'title' => esc_html__( 'Single Pages', 'emerge-pro' ),
			'description' => esc_html__( 'Settings for all single pages.', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Author enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_page_author',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => false,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_page_author',
		array(
			'section'		=> 'emerge_single_page_settings',
			'label'			=> esc_html__( 'Enable author.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Featured image enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_page_featured_img',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_page_featured_img',
		array(
			'section'		=> 'emerge_single_page_settings',
			'label'			=> esc_html__( 'Enable featured image.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Pagination enable setting
	$wp_customize->add_setting(
		'emerge_enable_single_page_pagination',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => false,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_single_page_pagination',
		array(
			'section'		=> 'emerge_single_page_settings',
			'label'			=> esc_html__( 'Enable pagination.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	/**
	 * Footer copyright
	 */
	// Footer copyright
	$wp_customize->add_section(
		'emerge_footer_section',
		array(
			'title' => esc_html__( 'Footer section', 'emerge-pro' ),
			'panel' => 'emerge_general_panel',
		)
	);

	// Footer social menu enable setting
	$wp_customize->add_setting(
		'emerge_enable_footer_social_menu',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_footer_social_menu',
		array(
			'section'		=> 'emerge_footer_section',
			'label'			=> esc_html__( 'Enable social menu.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Footer text enable setting
	$wp_customize->add_setting(
		'emerge_enable_footer_text',
		array(
			'sanitize_callback' => 'emerge_sanitize_checkbox',
			'default' => true,
		)
	);

	$wp_customize->add_control(
		'emerge_enable_footer_text',
		array(
			'section'		=> 'emerge_footer_section',
			'label'			=> esc_html__( 'Enable footer text.', 'emerge-pro' ),
			'type'			=> 'checkbox',
		)
	);

	// Footer copyright setting
	$wp_customize->add_setting(
		'emerge_copyright_txt',
		array(
			'sanitize_callback' => 'emerge_sanitize_html',
			'default' => $default['emerge_copyright_txt'],
			'transport'	=> 'postMessage',
		)
	);

	$wp_customize->add_control(
		'emerge_copyright_txt',
		array(
			'section'		=> 'emerge_footer_section',
			'label'			=> esc_html__( 'Copyright text:', 'emerge-pro' ),
			'type'			=> 'textarea',
			'active_callback' => 'emerge_if_footer_text_enable',
		)
	);

	$wp_customize->selective_refresh->add_partial( 
		'emerge_copyright_txt', 
		array(
	        'selector'            => '#colophon .site-info .footer-copyright',
			'render_callback'     => 'emerge_copyright_partial',
    	) 
    );
}
add_action( 'customize_register', 'emerge_customize_register' );

/**
 * Render the site title for the selective refresh partial.
 *
 * @return void
 */
function emerge_customize_partial_blogname() {
	bloginfo( 'name' );
}

/**
 * Render the site tagline for the selective refresh partial.
 *
 * @return void
 */
function emerge_customize_partial_blogdescription() {
	bloginfo( 'description' );
}

/**
 * Binds JS handlers to make Theme Customizer preview reload changes asynchronously.
 */
function emerge_customize_preview_js() {
	wp_enqueue_script( 'emerge-customizer', get_theme_file_uri( '/assets/js/customizer.js' ), array( 'customize-preview' ), '20151215', true );
}
add_action( 'customize_preview_init', 'emerge_customize_preview_js' );

/**
 * Binds JS handlers for Customizer controls.
 */
function emerge_customize_control_js() {


	wp_enqueue_script( 'emerge-customize-control', get_theme_file_uri( '/assets/js/customize-control.js' ), array( 'jquery', 'customize-controls' ), '20151215', true );
	$localized_data = array( 
		'refesh_msg' => esc_html__( 'Refresh the page after Save and Publish.', 'emerge-pro' ),
	);

	wp_localize_script( 'emerge-customize-control', 'localized_data', $localized_data );
}
add_action( 'customize_controls_enqueue_scripts', 'emerge_customize_control_js' );

/**
 *
 * Sanitization callbacks.
 * 
 */

/**
 * Checkbox sanitization callback example.
 * 
 * Sanitization callback for 'checkbox' type controls. This callback sanitizes `$checked`
 * as a boolean value, either TRUE or FALSE.
 *
 * @param bool $checked Whether the checkbox is checked.
 * @return bool Whether the checkbox is checked.
 */
function emerge_sanitize_checkbox( $checked ) {
	// Boolean check.
	return ( ( isset( $checked ) && true == $checked ) ? true : false );
}


/**
 * HEX Color sanitization callback example.
 *
 * - Sanitization: hex_color
 * - Control: text, WP_Customize_Color_Control
 *
 */
function emerge_sanitize_hex_color( $hex_color, $setting ) {
	// Sanitize $input as a hex value without the hash prefix.
	$hex_color = sanitize_hex_color( $hex_color );
	
	// If $input is a valid hex value, return it; otherwise, return the default.
	return ( ! is_null( $hex_color ) ? $hex_color : $setting->default );
}

/**
 * Image sanitization callback example.
 *
 * Checks the image's file extension and mime type against a whitelist. If they're allowed,
 * send back the filename, otherwise, return the setting default.
 *
 * - Sanitization: image file extension
 * - Control: text, WP_Customize_Image_Control
 */
function emerge_sanitize_image( $image, $setting ) {
	/*
	 * Array of valid image file types.
	 *
	 * The array includes image mime types that are included in wp_get_mime_types()
	 */
    $mimes = array(
        'jpg|jpeg|jpe' => 'image/jpeg',
        'gif'          => 'image/gif',
        'png'          => 'image/png',
        'bmp'          => 'image/bmp',
        'tif|tiff'     => 'image/tiff',
        'ico'          => 'image/x-icon',
        'svg'          => 'image/svg+xml'
    );
	// Return an array with file extension and mime_type.
    $file = wp_check_filetype( $image, $mimes );
	// If $image has a valid mime_type, return it; otherwise, return the default.
    return ( $file['ext'] ? $image : $setting->default );
}

/**
 * Select sanitization callback example.
 *
 * - Sanitization: select
 * - Control: select, radio
 */
function emerge_sanitize_select( $input, $setting ) {
	
	// Ensure input is a slug.
	$input = sanitize_key( $input );
	
	// Get list of choices from the control associated with the setting.
	$choices = $setting->manager->get_control( $setting->id )->choices;
	
	// If the input is a valid key, return it; otherwise, return the default.
	return ( array_key_exists( $input, $choices ) ? $input : $setting->default );
}

/**
 * Drop-down Pages sanitization callback example.
 *
 * - Sanitization: dropdown-pages
 * - Control: dropdown-pages
 * 
 */
function emerge_sanitize_dropdown_pages( $page_id, $setting ) {
	// Ensure $input is an absolute integer.
	$page_id = absint( $page_id );
	
	// If $page_id is an ID of a published page, return it; otherwise, return the default.
	return ( 'publish' == get_post_status( $page_id ) ? $page_id : $setting->default );
}

/**
 * Number Range sanitization callback example.
 *
 * - Sanitization: number_range
 * - Control: number, tel
 * 
 */
function emerge_sanitize_number_range( $number, $setting ) {
	
	// Ensure input is an absolute integer.
	$number = absint( $number );
	
	// Get the input attributes associated with the setting.
	$atts = $setting->manager->get_control( $setting->id )->input_attrs;
	
	// Get minimum number in the range.
	$min = ( isset( $atts['min'] ) ? $atts['min'] : $number );
	
	// Get maximum number in the range.
	$max = ( isset( $atts['max'] ) ? $atts['max'] : $number );
	
	// Get step.
	$step = ( isset( $atts['step'] ) ? $atts['step'] : 1 );
	
	// If the number is within the valid range, return it; otherwise, return the default
	return ( $min <= $number && $number <= $max && is_int( $number / $step ) ? $number : $setting->default );
}

/**
 * HTML sanitization callback example.
 *
 * - Sanitization: html
 * - Control: text, textarea
 *
 * @param string $html HTML to sanitize.
 * @return string Sanitized HTML.
 */
function emerge_sanitize_html( $html ) {
	return wp_filter_post_kses( $html );
}

/**
 *
 * Active callbacks.
 * 
 */


/**
 * Check if the hero content is enable
 */
function emerge_if_hero_content_enable( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_hero_content' )->value();
}

/**
 * Check if the hero content is custom
 */
function emerge_if_hero_content_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_hero_content' )->value();
}

/**
 * Check if the hero content is page
 */
function emerge_if_hero_content_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_hero_content' )->value();
}

/**
 * Check if the hero content is post
 */
function emerge_if_hero_content_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_hero_content' )->value();
}

/**
 * Check if the about is custom
 */
function emerge_if_about_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_about' )->value();
}

/**
 * Check if the about is page
 */
function emerge_if_about_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_about' )->value();
}

/**
 * Check if the about is post
 */
function emerge_if_about_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_about' )->value();
}

/**
 * Check if the about is not disabled
 */
function emerge_if_about_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_about' )->value();
}

/**
 * Check if the cta is custom
 */
function emerge_if_cta_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_cta' )->value();
}

/**
 * Check if the cta is page
 */
function emerge_if_cta_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_cta' )->value();
}

/**
 * Check if the cta is post
 */
function emerge_if_cta_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_cta' )->value();
}

/**
 * Check if the cta is not disabled
 */
function emerge_if_cta_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_cta' )->value();
}

/**
 * Check if the portfolio is not disabled
 */
function emerge_if_portfolio_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_portfolio' )->value();
}

/**
 * Check if the portfolio is page
 */
function emerge_if_portfolio_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_portfolio' )->value();
}

/**
 * Check if the portfolio is post
 */
function emerge_if_portfolio_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_portfolio' )->value();
}

/**
 * Check if the portfolio is cat
 */
function emerge_if_portfolio_cat( $control ) {
	return 'cat' === $control->manager->get_setting( 'emerge_portfolio' )->value();
}

/**
 * Check if the portfolio is custom
 */
function emerge_if_portfolio_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_portfolio' )->value();
}

/**
 * Check if the portfolio is not disabled or category.
 */
function emerge_if_portfolio_not_cat_disabled( $control ) {
	return ( ! emerge_if_portfolio_cat( $control ) && emerge_if_portfolio_not_disabled( $control ) );
}

/**
 * Check if the services is not disabled
 */
function emerge_if_services_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_services' )->value();
}

/**
 * Check if the services is page
 */
function emerge_if_services_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_services' )->value();
}

/**
 * Check if the services is post
 */
function emerge_if_services_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_services' )->value();
}

/**
 * Check if the services is cat
 */
function emerge_if_services_cat( $control ) {
	return 'cat' === $control->manager->get_setting( 'emerge_services' )->value();
}

/**
 * Check if the services is custom
 */
function emerge_if_services_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_services' )->value();
}

/**
 * Check if the services is not disabled or category.
 */
function emerge_if_services_not_cat_disabled( $control ) {
	return ( ! emerge_if_services_cat( $control ) && emerge_if_services_not_disabled( $control ) );
}

/**
 * Check if the reasons is enable
 */
function emerge_if_reasons_enable( $control ) {
	return $control->manager->get_setting( 'emerge_reasons_enable' )->value();
}

/**
 * Check if the reasons is page
 */
function emerge_if_reasons_page( $control ) {
	return emerge_if_reasons_enable( $control ) && 'page' === $control->manager->get_setting( 'emerge_reasons_content' )->value();
}

/**
 * Check if the reasons is post
 */
function emerge_if_reasons_post( $control ) {
	return emerge_if_reasons_enable( $control ) && 'post' === $control->manager->get_setting( 'emerge_reasons_content' )->value();
}

/**
 * Check if the reasons is custom
 */
function emerge_if_reasons_custom( $control ) {
	return emerge_if_reasons_enable( $control ) && 'custom' === $control->manager->get_setting( 'emerge_reasons_content' )->value();
}

/**
 * Check if the reasons's left is not disabled.
 */
function emerge_if_reasons_left_not_disable( $control ) {
	return emerge_if_reasons_enable( $control ) && ( 'disable' != $control->manager->get_setting( 'emerge_reasons_content' )->value() );
}

/**
 * Check if the reasons skill is enabled.
 */
function emerge_if_reasons_skill_enable( $control ) {
	return emerge_if_reasons_enable( $control ) && $control->manager->get_setting( 'emerge_reasons_skill_enable' )->value();
}

/**
 * Check if the video is enabled.
 */
function emerge_if_video_enable( $control ) {
	return $control->manager->get_setting( 'emerge_video_enable' )->value();
}

/**
 * Check if the team is not disabled
 */
function emerge_if_team_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_team' )->value();
}

/**
 * Check if the team is cat
 */
function emerge_if_team_cat( $control ) {
	return 'cat' === $control->manager->get_setting( 'emerge_team' )->value();
}

/**
 * Check if the team is custom
 */
function emerge_if_team_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_team' )->value();
}

/**
 * Check if the team is page
 */
function emerge_if_team_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_team' )->value();
}

/**
 * Check if the team is post
 */
function emerge_if_team_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_team' )->value();
}

/**
 * Check if the counter is enabled.
 */
function emerge_if_counter_enable( $control ) {
	return $control->manager->get_setting( 'emerge_enable_counter' )->value();
}

/**
 * Check if the testimonial is not disabled
 */
function emerge_if_testimonial_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_testimonial' )->value();
}

/**
 * Check if the testimonial is page
 */
function emerge_if_testimonial_page( $control ) {
	return 'page' === $control->manager->get_setting( 'emerge_testimonial' )->value();
}

/**
 * Check if the testimonial is post
 */
function emerge_if_testimonial_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_testimonial' )->value();
}

/**
 * Check if the testimonial is cat
 */
function emerge_if_testimonial_cat( $control ) {
	return 'cat' === $control->manager->get_setting( 'emerge_testimonial' )->value();
}

/**
 * Check if the testimonial is custom
 */
function emerge_if_testimonial_custom( $control ) {
	return 'custom' === $control->manager->get_setting( 'emerge_testimonial' )->value();
}

/**
 * Check if the partner is enabled.
 */
function emerge_if_partner_enable( $control ) {
	return $control->manager->get_setting( 'emerge_enable_partner' )->value();
}

/**
 * Check if the blog section is not disabled
 */
function emerge_if_blog_section_not_disabled( $control ) {
	return 'disable' != $control->manager->get_setting( 'emerge_blog_section' )->value();
}

/**
 * Check if the blog section is cat
 */
function emerge_if_blog_section_cat( $control ) {
	return 'cat' === $control->manager->get_setting( 'emerge_blog_section' )->value();
}

/**
 * Check if the blog section is post
 */
function emerge_if_blog_section_post( $control ) {
	return 'post' === $control->manager->get_setting( 'emerge_blog_section' )->value();
}

/**
 * Check if the subscribe is enabled.
 */
function emerge_if_subscribe_enable( $control ) {
	return $control->manager->get_setting( 'emerge_enable_subscribe' )->value();
}

/**
 * Check if the pricing is enable
 */
function emerge_if_pricing_enabled( $control ) {
	return $control->manager->get_setting( 'emerge_enable_pricing' )->value();
}

/**
 * Check if the contact is not disabled
 */
function emerge_if_contact_not_disabled( $control ) {
	return $control->manager->get_setting( 'emerge_enable_contact' )->value();
}

/**
 * Check if the footer text is enabled
 */
function emerge_if_footer_text_enable( $control ) {
	return $control->manager->get_setting( 'emerge_enable_footer_text' )->value();
}


/**
 * Selective refresh.
 */

/**
 * Selective refresh for hero content text.
 */
function emerge_hero_content_partial_text() {
	return wp_kses_post( get_theme_mod( 'emerge_hero_content_text' ) );
}

/**
 * Selective refresh for about title.
 */
function emerge_about_partial_title() {
	return esc_html( get_theme_mod( 'emerge_about_title' ) );
}

/**
 * Selective refresh for about sub title.
 */
function emerge_about_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_about_sub_title' ) );
}

/**
 * Selective refresh for about content.
 */
function emerge_about_partial_content() {
	return wp_kses_post( get_theme_mod( 'emerge_about_content' ) );
}

/**
 * Selective refresh for about btn text.
 */
function emerge_about_partial_btn_txt() {
	return esc_html( get_theme_mod( 'emerge_about_btn_txt' ) );
}

/**
 * Selective refresh for cta title.
 */
function emerge_cta_partial_title() {
	return esc_html( get_theme_mod( 'emerge_cta_title' ) );
}

/**
 * Selective refresh for cta btn text.
 */
function emerge_cta_partial_btn_txt() {
	return esc_html( get_theme_mod( 'emerge_cta_btn_txt' ) );
}

/**
 * Selective refresh for cta content.
 */
function emerge_cta_partial_text() {
	return wp_kses_post( get_theme_mod( 'emerge_cta_text' ) );
}

/**
 * Selective refresh for portfolio title.
 */
function emerge_portfolio_partial_title() {
	return esc_html( get_theme_mod( 'emerge_portfolio_title' ) );
}

/**
 * Selective refresh for portfolio btn text.
 */
function emerge_portfolio_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_portfolio_sub_title' ) );
}

/**
 * Selective refresh for portfolio btn text.
 */
function emerge_portfolio_partial_btn_txt() {
	return esc_html( get_theme_mod( 'emerge_portfolio_btn_txt' ) );
}

/**
 * Selective refresh for blog section title.
 */
function emerge_blog_section_partial_title() {
	return esc_html( get_theme_mod( 'emerge_blog_section_title' ) );
}

/**
 * Selective refresh for blog section text.
 */
function emerge_blog_section_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_blog_section_sub_title' ) );
}

/**
 * Selective refresh for contact title.
 */
function emerge_contact_partial_title() {
	return esc_html( get_theme_mod( 'emerge_contact_title' ) );
}

/**
 * Selective refresh for contact subt title.
 */
function emerge_contact_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_contact_sub_title' ) );
}

/**
 * Selective refresh for footer copyright.
 */
function emerge_copyright_partial() {
	return wp_kses_post( get_theme_mod( 'emerge_copyright_txt' ) );
}

/**
 * Selective refresh for your latest posts title.
 */
function emerge_your_latest_posts_partial_title() {
	return esc_html( get_theme_mod( 'emerge_your_latest_posts_title' ) );
}

/**
 * Selective refresh for services title.
 */
function emerge_services_partial_title() {
	return esc_html( get_theme_mod( 'emerge_services_title' ) );
}

/**
 * Selective refresh for services btn text.
 */
function emerge_services_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_services_sub_title' ) );
}

/**
 * Selective refresh for reasons title.
 */
function emerge_reasons_partial_title() {
	return esc_html( get_theme_mod( 'emerge_reasons_title' ) );
}

/**
 * Selective refresh for reasons btn text.
 */
function emerge_reasons_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_reasons_sub_title' ) );
}

/**
 * Selective refresh for reasons custom content.
 */
function emerge_reasons_partial_custom_content() {
	return esc_html( get_theme_mod( 'emerge_reasons_custom_content' ) );
}

/**
 * Selective refresh for reasons button text
 */
function emerge_reasons_partial_custom_btn_text() {
	return esc_html( get_theme_mod( 'emerge_reasons_custom_btn_txt' ) );
}

/**
 * Selective refresh for team title.
 */
function emerge_team_partial_title() {
	return esc_html( get_theme_mod( 'emerge_team_title' ) );
}

/**
 * Selective refresh for team btn text.
 */
function emerge_team_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_team_sub_title' ) );
}

/**
 * Selective refresh for testimonial title.
 */
function emerge_testimonial_partial_title() {
	return esc_html( get_theme_mod( 'emerge_testimonial_title' ) );
}

/**
 * Selective refresh for testimonial btn text.
 */
function emerge_testimonial_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_testimonial_sub_title' ) );
}

/**
 * Selective refresh for subscribe title.
 */
function emerge_subscribe_partial_title() {
	return esc_html( get_theme_mod( 'emerge_subscribe_title' ) );
}

/**
 * Selective refresh for subscribe text.
 */
function emerge_subscribe_partial_text() {
	return esc_html( get_theme_mod( 'emerge_subscribe_text' ) );
}

/**
 * Selective refresh for pricing title.
 */
function emerge_pricing_partial_title() {
	return esc_html( get_theme_mod( 'emerge_pricing_title' ) );
}

/**
 * Selective refresh for pricing btn text.
 */
function emerge_pricing_partial_sub_title() {
	return esc_html( get_theme_mod( 'emerge_pricing_sub_title' ) );
}